/*
	HimeyaSoft
*/
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <string.h>

unsigned long decodeLZ( FILE *in, unsigned long size, FILE *out )
{
	unsigned char	buf[256];
	unsigned char	*dic;
	unsigned char	*HL;
	unsigned long	dicpos = 0x0FEE;
	unsigned char	byte;
	unsigned char	sign;
	unsigned int	decode_startaddr;
	unsigned int	decode_length;
	int				i;
	int				q;
	unsigned long	decode_byte = 0L;
	unsigned long	read_byte = 0L;
	unsigned long	addr = 0L;

	dic = ( unsigned char * )calloc( 1, 4096 );
	HL = dic;

	/* Initial Dic */
	for( i = 0; i < 0x100; i++ )
	{
		memset( HL, i, 13 );
		HL += 13;
	}
	for( i = 0; i < 0x0100; i++ )
	{
		*HL = i;
		HL++;
	}
	for( i = 0; i < 0x0100; i++ )
	{
		*HL = 0xFF - i;
		HL++;
	}
	memset( HL, 0x00, 0x80 );
	HL += 0x80;
	memset( HL, 0x20, 0x6E );

	while( read_byte <= size )
	{
		/* compress sign */
		fread( buf, 1, 1, in ); sign = buf[0];
		read_byte++;

		for( i = 0; i != 8; i++ )
		{
			if( sign & 1 )
			{
				fread( buf, 1, 1, in ); byte = buf[0];
				dic[dicpos] = byte;
				fprintf( out, "%c", byte );
				dicpos++; dicpos &= 0x0FFF;
				read_byte++; decode_byte++;
			} else {
				fread( buf, 2, 1, in ); 
				decode_length = ( buf[1] & 0x0F ) + 0x03;
				decode_startaddr  = ( buf[1] & 0xF0 ) << 4;
				decode_startaddr += buf[0];
				read_byte += 2;

				/* decode */
				for( q = 0; q != decode_length; q++ )
				{
					addr = decode_startaddr + q; addr &= 0x0FFF;
					dic[dicpos] = dic[addr];
					fprintf( out, "%c", dic[addr] );
					dicpos++; dicpos &= 0x0FFF;
					decode_byte++;
				}
			}
			sign >>= 1;
			if( read_byte >= size ) break;
		}
		if( read_byte >= size ) break;
	}
	free( dic );
	return decode_byte;
}

void main( int ac, char **av )
{
	FILE				*in;
	FILE				*out;
	char				outfilename[256];
	unsigned char		tmp[12];
	unsigned long		filesize = 0L;
	unsigned long		filesize_compress = 0L;
	unsigned long		filesize_original = 0L;

	printf( "HimeyaSoft LZ Decompress tool 070522 (c)Fac.KUROHANE/UME-3\n" );

	if( ac == 1 )
	{
		printf( "usage: HMY8EXT <filename>\n" );
		return;
	}

	in = fopen( av[1], "rb" );
	if( in == NULL )
	{
		printf( "error: can't open %s\n", av[1] );
		return;
	}
	printf( "filename: %s\n", av[1] );

	/* filesize */
	fseek( in, 0x00, SEEK_END );
	filesize = ftell( in );

	fseek( in, 0x00, SEEK_SET );
	fread( tmp, 10, 1, in );

	/* filesize_compress */
	filesize_compress = *( unsigned long *)( tmp );

	if(( filesize - 8 ) != filesize_compress )
	{
		printf( "error: not LZ file.\n" );
		fclose( in );
		return;
	}

	printf( "fileisize_compress: %lu(%04lX)\n",
		filesize_compress,
		filesize_compress
	);

	if( ac == 3 ) sprintf( outfilename, "%s%s", av[2], av[1] );
	else sprintf( outfilename, "%s", av[1] );
	out = fopen( outfilename, "wb+" );
	if( out == NULL )
	{
		printf( "error: can't open %s\n", outfilename );
		fclose( in );
		return;
	}

	/* LZ extract */
	fseek( in , 0x08, SEEK_SET );
	filesize_original = decodeLZ( in, filesize_compress - 0x08, out );
	printf( "filesize_original: %lu(%04lX)\n",
		filesize_original,
		filesize_original
	);

	fclose( in );
	fclose( out );

	printf( "\n" );
	printf( "complete.\n" );

/*
	remove( av[1] );
	rename( tmpname, av[1] );
*/
	return;
}
